Index: LMDZ4/branches/LMDZ4V5.0-dev/libf/dyn3dpar/dynetat0.F
===================================================================
--- LMDZ4/branches/LMDZ4V5.0-dev/libf/dyn3dpar/dynetat0.F	(revision 1292)
+++ LMDZ4/branches/LMDZ4V5.0-dev/libf/dyn3dpar/dynetat0.F	(revision 1380)
@@ -1,7 +1,8 @@
 !
-! $Header$
+! $Id $
 !
       SUBROUTINE dynetat0(fichnom,vcov,ucov,
      .                    teta,q,masse,ps,phis,time)
+
       USE infotrac
       IMPLICIT NONE
@@ -33,4 +34,5 @@
 #include "serre.h"
 #include "logic.h"
+#include "iniprint.h"
 
 c   Arguments:
@@ -52,10 +54,11 @@
 
 c-----------------------------------------------------------------------
+
 c  Ouverture NetCDF du fichier etat initial
 
       ierr = NF_OPEN (fichnom, NF_NOWRITE,nid)
       IF (ierr.NE.NF_NOERR) THEN
-        write(6,*)' Pb d''ouverture du fichier start.nc'
-        write(6,*)' ierr = ', ierr
+        write(lunout,*)'dynetat0: Pb d''ouverture du fichier start.nc'
+        write(lunout,*)' ierr = ', ierr
         CALL ABORT
       ENDIF
@@ -64,5 +67,5 @@
       ierr = NF_INQ_VARID (nid, "controle", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <controle> est absent"
+         write(lunout,*)"dynetat0: Le champ <controle> est absent"
          CALL abort
       ENDIF
@@ -73,5 +76,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echoue pour <controle>"
+         write(lunout,*)"dynetat0: Lecture echoue pour <controle>"
          CALL abort
       ENDIF
@@ -119,5 +122,6 @@
 c
 c
-      PRINT*,'rad,omeg,g,cpp,kappa',rad,omeg,g,cpp,kappa
+      write(lunout,*)'dynetat0: rad,omeg,g,cpp,kappa',
+     &               rad,omeg,g,cpp,kappa
 
       IF(   im.ne.iim           )  THEN
@@ -134,5 +138,5 @@
       ierr = NF_INQ_VARID (nid, "rlonu", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <rlonu> est absent"
+         write(lunout,*)"dynetat0: Le champ <rlonu> est absent"
          CALL abort
       ENDIF
@@ -143,5 +147,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <rlonu>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <rlonu>"
          CALL abort
       ENDIF
@@ -149,5 +153,5 @@
       ierr = NF_INQ_VARID (nid, "rlatu", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <rlatu> est absent"
+         write(lunout,*)"dynetat0: Le champ <rlatu> est absent"
          CALL abort
       ENDIF
@@ -158,5 +162,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <rlatu>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <rlatu>"
          CALL abort
       ENDIF
@@ -164,5 +168,5 @@
       ierr = NF_INQ_VARID (nid, "rlonv", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <rlonv> est absent"
+         write(lunout,*)"dynetat0: Le champ <rlonv> est absent"
          CALL abort
       ENDIF
@@ -173,5 +177,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <rlonv>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <rlonv>"
          CALL abort
       ENDIF
@@ -179,5 +183,5 @@
       ierr = NF_INQ_VARID (nid, "rlatv", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <rlatv> est absent"
+         write(lunout,*)"dynetat0: Le champ <rlatv> est absent"
          CALL abort
       ENDIF
@@ -188,5 +192,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour rlatv"
+         write(lunout,*)"dynetat0: Lecture echouee pour rlatv"
          CALL abort
       ENDIF
@@ -194,5 +198,5 @@
       ierr = NF_INQ_VARID (nid, "cu", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <cu> est absent"
+         write(lunout,*)"dynetat0: Le champ <cu> est absent"
          CALL abort
       ENDIF
@@ -203,5 +207,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <cu>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <cu>"
          CALL abort
       ENDIF
@@ -209,5 +213,5 @@
       ierr = NF_INQ_VARID (nid, "cv", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <cv> est absent"
+         write(lunout,*)"dynetat0: Le champ <cv> est absent"
          CALL abort
       ENDIF
@@ -218,5 +222,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <cv>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <cv>"
          CALL abort
       ENDIF
@@ -224,5 +228,5 @@
       ierr = NF_INQ_VARID (nid, "aire", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <aire> est absent"
+         write(lunout,*)"dynetat0: Le champ <aire> est absent"
          CALL abort
       ENDIF
@@ -233,5 +237,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <aire>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <aire>"
          CALL abort
       ENDIF
@@ -239,5 +243,5 @@
       ierr = NF_INQ_VARID (nid, "phisinit", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <phisinit> est absent"
+         write(lunout,*)"dynetat0: Le champ <phisinit> est absent"
          CALL abort
       ENDIF
@@ -248,5 +252,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <phisinit>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <phisinit>"
          CALL abort
       ENDIF
@@ -254,5 +258,5 @@
       ierr = NF_INQ_VARID (nid, "temps", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <temps> est absent"
+         write(lunout,*)"dynetat0: Le champ <temps> est absent"
          CALL abort
       ENDIF
@@ -263,5 +267,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee <temps>"
+         write(lunout,*)"dynetat0: Lecture echouee <temps>"
          CALL abort
       ENDIF
@@ -269,5 +273,5 @@
       ierr = NF_INQ_VARID (nid, "ucov", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <ucov> est absent"
+         write(lunout,*)"dynetat0: Le champ <ucov> est absent"
          CALL abort
       ENDIF
@@ -278,5 +282,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <ucov>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <ucov>"
          CALL abort
       ENDIF
@@ -284,5 +288,5 @@
       ierr = NF_INQ_VARID (nid, "vcov", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <vcov> est absent"
+         write(lunout,*)"dynetat0: Le champ <vcov> est absent"
          CALL abort
       ENDIF
@@ -293,5 +297,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <vcov>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <vcov>"
          CALL abort
       ENDIF
@@ -299,5 +303,5 @@
       ierr = NF_INQ_VARID (nid, "teta", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <teta> est absent"
+         write(lunout,*)"dynetat0: Le champ <teta> est absent"
          CALL abort
       ENDIF
@@ -308,14 +312,16 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <teta>"
-         CALL abort
-      ENDIF
-
-
+         write(lunout,*)"dynetat0: Lecture echouee pour <teta>"
+         CALL abort
+      ENDIF
+
+
+      IF(nqtot.GE.1) THEN
       DO iq=1,nqtot
         ierr =  NF_INQ_VARID (nid, tname(iq), nvarid)
         IF (ierr .NE. NF_NOERR) THEN
-           PRINT*, "dynetat0: Le champ <"//tname(iq)//"> est absent"
-           PRINT*, "          Il est donc initialise a zero"
+           write(lunout,*)"dynetat0: Le champ <"//tname(iq)//
+     &                    "> est absent"
+           write(lunout,*)"          Il est donc initialise a zero"
            q(:,:,iq)=0.
         ELSE
@@ -326,13 +332,14 @@
 #endif
           IF (ierr .NE. NF_NOERR) THEN
-             PRINT*, "dynetat0: Lecture echouee pour "//tname(iq)
-             CALL abort
+            write(lunout,*)"dynetat0: Lecture echouee pour "//tname(iq)
+            CALL abort
           ENDIF
         ENDIF
       ENDDO
+      ENDIF
 
       ierr = NF_INQ_VARID (nid, "masse", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <masse> est absent"
+         write(lunout,*)"dynetat0: Le champ <masse> est absent"
          CALL abort
       ENDIF
@@ -343,5 +350,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <masse>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <masse>"
          CALL abort
       ENDIF
@@ -349,5 +356,5 @@
       ierr = NF_INQ_VARID (nid, "ps", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Le champ <ps> est absent"
+         write(lunout,*)"dynetat0: Le champ <ps> est absent"
          CALL abort
       ENDIF
@@ -358,5 +365,5 @@
 #endif
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "dynetat0: Lecture echouee pour <ps>"
+         write(lunout,*)"dynetat0: Lecture echouee pour <ps>"
          CALL abort
       ENDIF