Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 1411)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 1412)
@@ -1,4 +1,3 @@
 ! $Id$
-!
 c#define IO_DEBUG
 
@@ -262,5 +261,4 @@
       CHARACTER*4 bb2
       CHARACTER*2 bb3
-c
 
       real twriteSTD(klon,nlevSTD,nfiles)
@@ -865,4 +863,5 @@
       REAL rflag(klon)          ! flag fonctionnement de convect
       INTEGER iflagctrl(klon)          ! flag fonctionnement de convect
+
 c -- convect43:
       INTEGER ntra              ! nb traceurs pour convect4.3
@@ -1233,5 +1232,4 @@
       call phys_state_var_init(read_climoz)
       call phys_output_var_init
-
       print*, '================================================='
 cIM for NMC files
@@ -1253,4 +1251,5 @@
 c         pmflxr=0.
 c         pmflxs=0.
+
         itau_con=0
         first=.false.
@@ -1424,5 +1423,5 @@
            ema_pcb(i)  = 0.
            ema_pct(i)  = 0.
-           ema_workcbmf(i) = 0.
+c          ema_workcbmf(i) = 0.
           ENDDO
 cIM15/11/02 rajout initialisation ibas_con,itop_con cf. SB =>BEG
@@ -1449,5 +1448,5 @@
 c================================================================================
 
-         ENDIF
+         ENDIF !debut
 
            DO i=1,klon
@@ -2171,5 +2170,5 @@
      .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
      .        rain_con, snow_con, ibas_con, itop_con, sigd,
-     .        upwd,dnwd,dnwd0,
+     .        ema_cbmf,upwd,dnwd,dnwd0,
      .        Ma,mip,Vprecip,cape,cin,tvp,Tconv,iflagctrl,
      .        pbase,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,qcondc,wd,
@@ -2190,4 +2189,5 @@
 
           ELSE ! ok_cvl
+
 c MAF conema3 ne contient pas les traceurs
           CALL conema3 (dtime,
@@ -2229,8 +2229,7 @@
 
           DO i = 1, klon
-            ema_pcb(i)  = pbase(i)
+            ema_pcb(i)  = paprs(i,ibas_con(i))
           ENDDO
           DO i = 1, klon
-
 ! L'idicage de itop_con peut cacher un pb potentiel
 ! FH sous la dictee de JYG, CR
@@ -2243,8 +2242,5 @@
               endif
             endif
-          ENDDO
-          DO i = 1, klon
-            ema_cbmf(i) = ema_workcbmf(i)
-          ENDDO      
+          ENDDO     
       ELSE IF (iflag_con.eq.0) THEN
           write(lunout,*) 'On n appelle pas la convection'
@@ -2463,5 +2459,5 @@
 c  ==============
 
-! Dans le cas où on active les thermiques, on fait partir l'ajustement
+! Dans le cas oÃ¹ on active les thermiques, on fait partir l'ajustement
 ! a partir du sommet des thermiques.
 ! Dans le cas contraire, on demarre au niveau 1.
@@ -2547,6 +2543,6 @@
      s   (klon,klev,q_seri,zqsat,clwcon0th,ptconvth,ratqsc,rnebcon0th)
          if(prt_level.ge.9) print*,' CLOUDS_GNO OK'
-
-      endif
+       
+       endif
 
 c   ratqs stables
@@ -2611,5 +2607,5 @@
 
       if (iflag_cldcon.eq.1 .or.iflag_cldcon.eq.2
-     s    .or.iflag_cldcon.eq.4) then
+     s    .or.iflag_cldcon.ge.4) then
 
 ! On ajoute une constante au ratqsc*2 pour tenir compte de 
@@ -2646,5 +2642,4 @@
       endif
 
-      print*,'PHSYIQ NUAGES4'
 
 c
@@ -2842,6 +2837,6 @@
       else
 ! Ancienne version
-         cldfra(:,:)=min(max(cldfra(:,:),rnebcon(:,:)),1.)
-         cldliq(:,:)=cldliq(:,:)+rnebcon(:,:)*clwcon(:,:)
+      cldfra(:,:)=min(max(cldfra(:,:),rnebcon(:,:)),1.)
+      cldliq(:,:)=cldliq(:,:)+rnebcon(:,:)*clwcon(:,:)
       endif
 
@@ -3312,6 +3307,7 @@
 !     s        ref_liq,ref_ice
           call phys_cosp(itap,dtime,freq_cosp,
-     $                 ecrit_mth,ecrit_day,ecrit_hf,overlap,
-     $                   klon,klev,rlon,rlat,presnivs,
+     $                   ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP,
+     $                   ecrit_mth,ecrit_day,ecrit_hf,
+     $                   klon,klev,rlon,rlat,presnivs,overlap,
      $                   ref_liq,ref_ice,
      $                   pctsrf(:,is_ter)+pctsrf(:,is_lic),
@@ -3322,4 +3318,5 @@
      $                   pmflxr(:,1:klev),pmflxs(:,1:klev),
      $                   mr_ozone,cldtau, cldemi)
+
 !     L          calipso2D,calipso3D,cfadlidar,parasolrefl,atb,betamol,
 !     L          cfaddbze,clcalipso2,dbze,cltlidarradar,
@@ -3469,4 +3466,5 @@
       wwriteSTD(:,:,4)=wlevSTD(:,:)
 c
+cIM initialisation 5eme fichier de sortie 
 cIM ajoute 5eme niveau 170310 BEG
       twriteSTD(:,:,5)=tlevSTD(:,:)
@@ -3581,4 +3579,5 @@
 cIM global posePB#include "write_bilKP_ave.h"
 c
+
 c Sauvegarder les valeurs de t et q a la fin de la physique:
 c
@@ -3639,5 +3638,8 @@
       DO k = 1, klev
       DO i = 1, klon
-        theta(i,k)=t(i,k)*(100000./pplay(i,k))**(RD/RCPD)
+cJYG/IM theta en debut du pas de temps
+cJYG/IM       theta(i,k)=t(i,k)*(100000./pplay(i,k))**(RD/RCPD)
+cJYG/IM theta en fin de pas de temps de physique
+        theta(i,k)=t_seri(i,k)*(100000./pplay(i,k))**(RD/RCPD)
       ENDDO
       ENDDO